
/* Network traffic analyzer
 * (c) 2001, Emil Mikulic.
 */

/* Big numbers - "arbitrary precision" arithmetic using strings */

#ifndef __BIGNUM_H
#define __BIGNUM_H

#include "version.h"

#define TWOPOW32 "4294967296"

typedef struct {
	dword hi, lo;
} i64;



__inline dword num_from_char(const byte c);

/* note: output needs to be deallocated */
__inline char *copy_str(const char *s);

/* note: output needs to be deallocated */
__inline char *bignum_from_int(const dword n);

/* note: output needs to be deallocated */
__inline char *add_bignum(char *a, char *b);

/* note: output needs to be deallocated */
__inline char *mul_bignum(char *a, char *b);

/* Add two 64-bit values given two pairs of 32-bit values */
__inline void add_64bit(i64 *dest, const i64 src);

/* note: output needs to be deallocated */
__inline char *bignum_from_64bit(const i64 val);

#endif

