
/* darkstat: a network traffic analyzer
 * (c) 2001, Emil Mikulic.
 */

/* Network [ab]use graph code */

#include "graph.h"
#include <assert.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>

dword graph_sec_in[GRAPH_SECONDS+1], graph_sec_out[GRAPH_SECONDS+1];
int pos_sec = 0;

pthread_t graph_thread;
pthread_mutex_t graph_mutex;



void graph_init(void)
{
	int i;

	for (i=0; i<GRAPH_SECONDS; i++)
		graph_sec_in[i] = graph_sec_out[i] = 0;
}



void graph_add_in(const dword amount)
{
	graph_sec_in[pos_sec] += amount;
}

void graph_add_out(const dword amount)
{
	graph_sec_out[pos_sec] += amount;
}



void graph_main(void *ptr)
{
	sigset_t sigset;

	sigfillset(&sigset);
	pthread_sigmask(SIG_BLOCK, &sigset, NULL);

	printf("GRAPH: Thread is awake and rotating graphs. (PID:%d)\n", getpid());

	while (1)
	{
		usleep(1000*MSEC);

		pthread_mutex_lock(&graph_mutex);
		pos_sec = (pos_sec + 1) % (GRAPH_SECONDS + 1);
		graph_sec_in[pos_sec] = graph_sec_out[pos_sec] = 0;
		pthread_mutex_unlock(&graph_mutex);
	}

	assert(0 && "Execution should never reach this point.");
	pthread_exit(0);
}

